-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Controls
	description: "Head radio button, default and knows selected"
	interface: abstract

deferred class HEAD_RADIO_BUTTON

inherit
	RADIO_BUTTON
		export
			{NONE} leader
		redefine
			set_leader
		end

feature -- Group management
	
	checked_radio_button: RADIO_BUTTON is
			-- Return the currently checked radio button from 
			-- the group lead by this one.
		local
			it: P_ITERATOR[RADIO_BUTTON]
		do
			if butlist = Void then
				Result := Current
			else
				from
					it := butlist.iterator
					it.first
				variant
					it.forward_variant
				until
					it.outside
				loop
					if it.item.is_checked then
						Result := it.item
						it.stop
					else
						it.forth
					end
				end
			end
		ensure
			done: Result /= Void
			one_only: -- return the first selected button, but should be unique.
		end

feature 
	
	set_leader (lead: HEAD_RADIO_BUTTON) is
			-- Head button is its own leader.
		do
		ensure then
			not_meaningful: false
		end

feature {NONE}
	
	butlist: P_LIST[RADIO_BUTTON]

	init_head_radio is
			-- Called by implementation at creation time.
		do
			!P_LINKED_LIST[RADIO_BUTTON]!butlist.make
			leader := Current
			butlist.add (Current)
			check_mark
		end

feature {RADIO_BUTTON} -- Self 

	add_button (rb: RADIO_BUTTON) is
		do
			butlist.add (rb)
			rb.uncheck_mark
		end

	uncheck_all (cur: RADIO_BUTTON) is
			-- Uncheck all buttons but 'cur'.
		local
			it: P_ITERATOR[RADIO_BUTTON]
		do
			from
				it := butlist.iterator
				it.first
			variant
				it.forward_variant
			until
				it.outside
			loop
				if it.item /= cur and then it.item.is_checked then
					it.item.uncheck_mark
				end
				it.forth
			end
		end

end -- class HEAD_RADIO_BUTTON
