-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Controls
	description: "Radio button"
	interface: abstract

deferred class RADIO_BUTTON

inherit
	CHECKBOX
		end

feature -- Optional leader 
	
	set_leader (lead: HEAD_RADIO_BUTTON) is
			-- Set optional leader radio button, which ensures 
			-- only one radio button is selected in a group with 
			-- a leader.
		require
			valid: lead /= Void
			--not_self: lead /= Current --? SmallEiffel problem
		do
			leader := lead
			leader.add_button (Current)
		ensure
			keep_reference: leader = lead
		end

feature {PUBLIC_NONE}
	
	leader: HEAD_RADIO_BUTTON;
			-- Optional leader.

end -- class RADIO_BUTTON
