-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Controls
	description: "Built-in comboxbox (string box with a drop-down listbox)"
	interface: client, inheritance

class STD_COMBOBOX[G -> LISTBOX_ITEM]

inherit
	STD_DROPDOWN_LISTBOX[G] -- gets LISTBOX and STD_CONTROL
		undefine
			when_down, when_up
		redefine
			make, make_unsorted, 
			register, std_control_when_command
		end
	STD_STRINGBOX -- gets STRINGBOX
		rename
			has_selection as clipboard_has_selection
		undefine
			make, register, std_control_when_command, 
			indep_set_size, default_size, default_height
		redefine
			clipboard_has_selection
		end

creation
	make, make_unsorted

feature {CREATION_NONE} -- Creation
	
	make (p: WINDOW) is
			-- Create combobox.
		do
			!!self.make_handle (p, wrt.win_combo_create (p.handle, true, true))
			register
		end

	make_unsorted (p: WINDOW) is
			-- Create combobox whose list is unsorted.
		do
			!!self.make_handle (p, wrt.win_combo_create (p.handle, true, false))
			register
		end

feature {NONE}
	
	register is
			-- Register.
		local
			editctl: INTEGER
		do
			std_dropdown_listbox_register -- Precursor
			
			-- subclass combo's edit control
			editctl := wrt.win_combo_editctl (self.handle)
			notifier.register_combobox_edit (Current, editctl)
			wrt.win_subclass_control (editctl)
		end

feature -- Status

	clipboard_has_selection: BOOLEAN is
			-- Has current selection?
		do
			Result := wrt.win_msg_bool (self.handle, wrt.Cb_geteditsel) -- /= 0, not really a boolean value
		end

feature {NONE} -- Event(s)

	std_control_when_command (not_code: INTEGER) is
		require else
			true
		do
			if not_code = wrt.Cbn_editchange then
				when_changed
			elseif not_code = wrt.Cbn_selchange then
				when_selected
			elseif not_code = wrt.Cbn_closeup then
				when_executed
			elseif not_code = wrt.Cbn_errspace then
				wrt.raise_exception (wrt.Excep_combo)
			-- do nothing
			end
		end
	
end -- class STD_COMBOBOX
