-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Controls
	description: "Built-in multiple selection listbox"
	interface: client, inheritance
	
class STD_MULTIPLE_LISTBOX[G -> LISTBOX_ITEM]

inherit
	STD_LISTBOX[G]
		redefine
			make, make_unsorted, 
			reset_selection, get_curitem_idx
		end
	MULTIPLE_LISTBOX[G]
		end

creation
	make, make_unsorted

feature {CREATION_NONE} -- Creation

	make (p: WINDOW) is
			-- Create sorted listbox.
		do
			!!self.make_handle (p, wrt.win_listbox_create (p.handle, true, true))
			register
		end

	make_unsorted (p: WINDOW) is
			-- Create unsorted listbox.
		do
			!!self.make_handle (p, wrt.win_listbox_create (p.handle, true, false))
			register
		end

feature -- Items

	selected_range: P_LIST[G] is
			-- Selected items.
		local
			rlist: F_MEMORY
			i, nb_items: INTEGER
			ritem: G
			cnt: INTEGER
		do
			!P_LINKED_LIST[G]!Result.make

			cnt := wrt.win_msg_int (self.handle, wrt.Lb_getselcount)
			check os_error: cnt /= wrt.Lb_err end
			!!rlist.make (cnt*4)

			nb_items := wrt.win_listbox_mitems (self.handle, rlist.to_windows, cnt)
			check got_them: cnt = nb_items end

			from
				i := 0
			until
				i >= cnt or else i >= nb_items
			loop
				ritem := get_curitem (rlist.double_word ((i*4)+1))
				if ritem /= Void then 
					Result.add (ritem)
				end
				i := i + 1
			end
		end

feature {NONE} -- Init selection

	reset_selection is
		do
			wrt.win_msg_setbool (self.handle, wrt.Lb_setsel, true)
		end

feature {NONE} -- Get current items

	get_curitem_idx: INTEGER is
		do
			Result := wrt.win_msg_int (self.handle, wrt.Lb_getcaretindex)
		end

end -- class STD_MULTIPLE_LISTBOX
