-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Controls
	description: "Built-in push button"
	interface: client, inheritance

class STD_PUSH_BUTTON

inherit
	STD_BUTTON
		redefine
			std_control_when_focus, std_control_when_focus_lost
		end
	PUSH_BUTTON
		end

creation
	make

feature {CREATION_NONE} -- Creation

	make (p: WINDOW) is
			-- Create the button.
		do
			!!self.make_handle (p, wrt.win_but_cpush (p.handle))
			register
		end

feature -- Status
	
	is_down: BOOLEAN is
			-- Is the button down?
		do
			Result := wrt.win_but_isdown (self.handle)
		end
		
	set_down (stat: BOOLEAN) is
			-- Not implemented.
		do
		ensure then
			not_implemented: false
		end
	
feature -- Default push button

	is_default: BOOLEAN
			-- Is the button a default push button?

	set_default (def: BOOLEAN) is
			-- Set the button to default push button status (thick border).
		do
			is_default := def
			wrt.win_but_default (self.handle, def)
		end

feature {NOTIFIER}
	
	std_control_when_focus is
		do
			get_default
			set_default (true)
		end

	std_control_when_focus_lost is
		do
			set_default (false)
			lose_default
		end

end -- class STD_PUSH_BUTTON
