-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Controls
	description: "Built-in radio button"
	interface: client, inheritance

class STD_RADIO_BUTTON

inherit
	STD_CHECKBOX
		redefine 
			make, when_executed,
			tabstop, arrowstop,
			check_mark
		end
	RADIO_BUTTON
		export
			{NONE} leader
		undefine
			when_executed
		end

creation
	make

feature {CREATION_NONE} -- Creation

	make (p: WINDOW) is
			-- Create the button.
		do
			!!self.make_handle (p, wrt.win_but_cradio (p.handle))
			leader := Void
			register
		end

feature {DIALOG} -- tabstop

	tabstop: BOOLEAN is
			-- Tab stop when radio checked.
		do
			Result := is_checked
		end

	arrowstop: BOOLEAN is
			-- Always stop on arrows.
		do
			Result := true
		end

feature -- Status

	check_mark is
			-- Set the check mark to checked status.
		do
			if leader /= Void then
				leader.uncheck_all (Current)
			end
			internal_check_mark -- Precursor
		end

feature {PUBLIC_NONE}

	when_executed, standard_when_executed is
			-- Default behaviour: set the selected radio button and 
			-- unset all radio buttons which are lead by same head button. 
		do
			if not is_checked then -- select us
				check_mark
			elseif leader /= Void then
				leader.uncheck_all (Current)
			end
		end

end -- class STD_RADIO_BUTTON
