-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Controls
	description: "Abstract control that holds an editable string"
	interface: abstract, inheritance

deferred class STRINGBOX

inherit
	DIALOG_ELEMENT
		end

feature 
	
	contents: STRING is
			-- Associated string.
		deferred
		ensure
			plain: contents /= Void
		end
	
	set_contents (s: STRING) is
			-- Change the associated string.
		require
			valid_string: s /= Void
		deferred
		ensure
			contents_set: contents.is_equal (s)
		end 

feature {NONE}
	
	command: GUI_COMMAND

feature
	
	set_command (gc: GUI_COMMAND) is
			-- Set when_changed command.
		require
			nothing: -- Void means no command
		do
			command := gc
		ensure
			keep_reference: command = gc
		end

feature {PUBLIC_NONE}
	
	when_changed is
			-- The contents has been changed by the user.
			-- Default: use command.
		do
			if command /= Void then
				command.execute
			end
		end

end -- class STRINGBOX
