-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Windows, Controls
	description: "Built-in scrollbar of a window"
	interface: client

class WINDOW_SCROLLBAR

inherit
	BASE_SCROLLBAR
		redefine
			when_slider_moved
		end

creation {CHILD_WINDOW}
	make_horizontal, make_vertical

feature {PUBLIC_NONE}
	
	parent: CHILD_WINDOW
	
feature {NONE}
	
	sb_handle: INTEGER is
		do
			Result := parent.handle
		end

feature {NONE} -- Creation

	make_horizontal (par: CHILD_WINDOW) is
		do
			parent := par
			type := wrt.Sb_horz
			init
		end

	make_vertical (par: CHILD_WINDOW) is
		do
			parent := par
			type := wrt.Sb_vert
			init
		end
	
feature 
	
	is_horizontal: BOOLEAN is
			-- Is this scrollbar horizontal?
		do
			Result := type = wrt.Sb_horz
		end

feature {PUBLIC_NONE} -- Event(s)
	
	when_slider_moved (dx: INTEGER) is
			-- Default event processing: forward to Windows callbacks.
		do
			if type = wrt.Sb_horz then
				parent.when_horizontal_scrolled (dx)
			elseif type = wrt.Sb_vert then
				parent.when_vertical_scrolled (dx)
			--? else exception
			end
		end

feature {CHILD_WINDOW}

	when_scroll (i1, i2: INTEGER) is
		do
			scrollbar_event (i1, i2)
		end

end -- class WINDOW_SCROLLBAR
