-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Graphics
	description: "Solid color brush"
	interface: client

class COLOR_BRUSH

inherit
	BRUSH
		end
	WIN_API
		end

creation
	make

feature {CREATION_NONE} -- Creation

	make, make_color is
		do
			!RGB_COLOR!color.white
		end

feature -- Colour

	set_color (col: COLOR) is
		require
			valid_color: col /= Void
		do
			color := col
		ensure
			keep_reference: color = col
		end

feature {NONE}
	
	color: COLOR

feature {WIN_API}
	
	to_windows: WIN_BRUSH is
		do
			!!Result.make_color (color)
		end
	
feature {WIN_PEN}
	
	to_color: COLOR is
		do
			Result := color
		end
	
	to_brush_style: INTEGER is
		do
			Result := wrt.Bs_solid
		end

	to_brush_hatch: INTEGER is
		do
			Result := 0
		end

invariant
	valid_color: color /= Void

end -- class COLOR_BRUSH
