-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Graphics
	description: "Bezier curve"
	interface: client
	
class DRAWABLE_BEZIER

inherit
	DRAWABLE_POLYLINE
		export
			{NONE} add_point -- SLV problem? (catched by invariant anyway)
		redefine
			draw
		end

creation
	make

feature -- Position
	
	set_start_point (pt: POINT) is
			-- Set the starting point
		require
			valid_point: pt /= Void
			empty: empty
		do
			add_line (pt)
		end

	add_curve (cp1, cp2, final: POINT) is
			-- Add a new bezier curve component. It will start from the 
			-- end of the previous curve or the starting point, and will 
			-- finish at the 'final' point. 'cp1' and 'cp2' are the control 
			-- points.
		require
			valid_points: cp1 /= Void and cp2 /= Void and final /= Void
			not_empty: not empty 
		do
			add_line (cp1)
			add_line (cp2)
			add_line (final)
		end

feature {GRAPHIC_DEVICE}
	
	draw (gd: GRAPHIC_DEVICE) is
		local
			aout: F_MEMORY
		do
			aout := to_points_array
			wrt.win_gdi_bezier (gd.handle, aout.to_windows, aout.size//4)
		end
	
invariant
	bezier_curve: line.count /= 0 implies line.count \\ 3 = 1

end -- class DRAWABLE_BEZIER
