-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Graphics
	description: "Metafile from the clipboard"
	interface: client

class DRAWABLE_CLIP_METAFILE

inherit
	DRAWABLE

	WIN_OBJECT

	WIN_RUNTIME_FINAL


creation {CLIPBOARD_METAFILE}
	make_handle

feature {NONE} -- Creation

	make_handle (h: INTEGER) is
		require
			valid: h /= 0
		do
			finalisation_register
			set_handle (h)
			!!position.make
		end

feature {NONE} -- Finalisation
	
	dispose is
			-- Finish.
		do
			--? relies on finalisation
			if handle /= Invalid_handle then
				win_gdi_delemf (handle)
				handle := Invalid_handle
			end
		end

feature {NONE}
	
	position: RECTANGLE

feature -- Status
	
	set_rectangle (rect: RECTANGLE) is
			-- Set rectangle in which to display the metafile.
		require
			valid: rect /= Void
		do
			position.copy (rect)
		end

feature {GRAPHIC_DEVICE}
	
	draw (gd: GRAPHIC_DEVICE) is
		do
			if is_valid_handle then
				wrt.win_gdi_drawemf (gd.handle, handle, position.lower.x, position.lower.y, position.upper.x, position.upper.y)
			end
		end

end -- class DRAWABLE_CLIP_METAFILE
