-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Graphics
	description: "Flood fill from a point"
	interface: client

class DRAWABLE_FLOODFILL

inherit
	DRAWABLE_POINT
		redefine
			make, draw
		select
			make
		end
	DRAWABLE_POINT
		rename
			make as old_make
		export
			{NONE} all
		undefine
			draw
		end

creation
	make

feature {CREATION_NONE} -- Creation

	make is
			-- Create floodfill primitive.
		do
			reset_mode
			old_make
		end

feature {NONE} -- (Internal) attribute(s)
	
	mode: INTEGER

feature -- Mode
	
	reset_mode, set_mode_border is
			-- Fill until a colour border of the colour defined by `set_color'.
			-- This is the default.
		do
			mode := wrt.Floodfillborder
		end

	set_mode_surface is
			-- Fill all surface having the colour defined by `set_color' and 
			-- adjacent to the starting point.
		do
			mode := wrt.Floodfillsurface
		end

feature {GRAPHIC_DEVICE}
	
	draw (gd: GRAPHIC_DEVICE) is
		local
			done: BOOLEAN
		do
			done := wrt.win_gdi_floodfill (gd.handle, position_x, position_y, color, mode)
		end

end -- class DRAWABLE_FLOODFIL
