-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Graphics
	description: "Graphics metafile (loaded from a file and drawn)"
	interface: client

class DRAWABLE_METAFILE

inherit
	DRAWABLE
		end

creation
	make

feature {CREATION_NONE} -- Creation

	make is
		do
			!!filename.make (0)
			!!position.make
		end

feature {NONE}
	
	filename: STRING
	position: RECTANGLE

feature -- Status
	
	set_file_name (fname: STRING) is
			-- Set file name.
		require
			valid: fname /= Void
		do
			filename.copy (fname)
		end

	set_rectangle (rect: RECTANGLE) is
			-- Set rectangle in which to display the metafile.
		require
			valid: rect /= Void
		do
			position.copy (rect)
		end

feature {GRAPHIC_DEVICE}
	
	draw (gd: GRAPHIC_DEVICE) is
		local
			emf_handle: INTEGER
		do
			emf_handle := wrt.win_gdi_getemf (wrt.ew_string (filename).to_c)
			if emf_handle /= 0 then
				wrt.win_gdi_drawemf (gd.handle, emf_handle, position.lower.x, position.lower.y, position.upper.x, position.upper.y)
				wrt.win_gdi_delemf (emf_handle)
			end
			
		end

end -- class DRAWABLE_METAFILE
