-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Graphics
	description: "Drawable polygon"
	comment: "The polygon is automatically closed (from the last point to the first)"
	interface: client

class DRAWABLE_POLYGON

inherit
	DRAWABLE_POLYLINE
		redefine
			draw
		end

creation
	make

feature {NONE} -- Drawing mode

	alternate_fill: BOOLEAN

feature -- Drawing mode

	reset_filling_mode, set_filling_mode_winding is
			-- Set default filling mode (fill everything inside the 
			-- polygon).
		do
			alternate_fill := false
		ensure
			done: alternate_fill = false
		end

	set_filling_mode_alternate is
			-- Set alternate filling mode (fill area between odd-numbered and 
			-- even-numbered polygon sides on each scan line).
		do
			alternate_fill := true
		ensure
			done: alternate_fill = true
		end

feature {GRAPHIC_DEVICE} -- Drawing

	draw (gd: GRAPHIC_DEVICE) is
		local
			aout: F_MEMORY
		do
			aout := to_points_array
			wrt.win_gdi_polymode (gd.handle, alternate_fill)
			wrt.win_gdi_polygon (gd.handle, aout.to_windows, aout.size//4)
		end

end -- class DRAWABLE_POLYGON
