-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Graphics
	description: "Draw a rectangle with a border"
	interface: client

class DRAWABLE_RECTANGLE

inherit
	DRAWABLE
		end

creation
	make

feature {CREATION_NONE} -- Creation
	
	make is
			-- Create object.
		do
			!!position.make
		end

feature {NONE} -- Internal position

	position: RECTANGLE
	
feature -- Position

	set_position (rect: RECTANGLE) is
			-- Set rectangle to be drawn.
		require
			valid_rectangle: rect /= Void
		do
			position.copy (rect)
		ensure
			done: position.is_equal (rect)
		end

feature {GRAPHIC_DEVICE} -- Drawing
	
	draw (gd: GRAPHIC_DEVICE) is
			-- Actual drawing
		local
			pt: POINT
			poly: DRAWABLE_POLYGON
		do
			!!pt.make
			!!poly.make

			poly.add_point (position.lower)
			pt.set_xy (position.lower.x, position.upper.y)
			poly.add_point (pt)
			poly.add_point (position.upper)
			pt.set_xy (position.upper.x, position.lower.y)
			poly.add_point (pt)
			
			gd.draw (poly)
		end

invariant
	valid_position: position /= Void
		
end -- class DRAWABLE_RECTANGLE
