-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Graphics
	description: "Round rectangle"
	interface: client

class DRAWABLE_ROUND_RECTANGLE

inherit
	DRAWABLE_RECTANGLE
		redefine
			make, draw
		select
			make
		end
	DRAWABLE_RECTANGLE
		rename 
			make as old_make
		export {NONE}
			all
		undefine
			draw
		end

creation
	make

feature {CREATION_NONE} -- Creation
	
	make is
			-- Creation.
		do
			round_width := 5
			round_height := 5
			old_make
		end

feature {NONE} -- Internal position

	round_width: INTEGER
	round_height: INTEGER

feature -- Position

	set_corner (width, height: INTEGER) is
			-- Set the width and height of the ellipse used to draw the 
			-- rounded corners of the rectangle.
		do
			round_width := width
			round_height := height
		ensure
			done: round_width = width and then round_height = height
		end

feature {GRAPHIC_DEVICE} -- Drawing 

	draw (gd: GRAPHIC_DEVICE) is
		do
			wrt.win_gdi_roundrect (gd.handle,
				position.lower.x, position.lower.y, position.upper.x, position.upper.y,
				round_width, round_height)
		end

end -- class DRAWABLE_ROUND_RECTANGLE
