-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Graphics
	description: "Hatched color brush"
	interface: client

class HATCHED_BRUSH

inherit
	COLOR_BRUSH
		redefine
			make, to_brush_style,
			to_brush_hatch, to_windows
		end

creation
	make

feature {CREATION_NONE} -- Creation

	make is
		do
			hatch := wrt.Hs_horizontal
			make_color
		end

feature -- Colour

	set_hatch_cross is
			-- Set hatch style: ++++++
		do
			hatch := wrt.Hs_cross
		end

	set_hatch_diagonal_cross is
			-- Set hatch style: xxxxxx
		do
			hatch := wrt.Hs_diagcross
		end

	set_hatch_horizontal is
			-- Set hatch style: ------
		do
			hatch := wrt.Hs_horizontal
		end

	set_hatch_vertical is
			-- Set hatch style: ||||||
		do
			hatch := wrt.Hs_vertical
		end
	
	set_hatch_forward_diagonal is
			-- Set hatch style: //////
		do
			hatch := wrt.Hs_fdiagonal
		end

	set_hatch_backward_diagonal is
			-- Set hatch style: \\\\\\
		do
			hatch := wrt.Hs_bdiagonal
		end

feature {NONE}
	
	hatch: INTEGER

feature {WIN_API}
	
	to_windows: WIN_BRUSH is
		do
			!!Result.make_hatch (color, hatch)
		end
	
feature {WIN_PEN}
	
	to_brush_style: INTEGER is
		do
			Result := wrt.Bs_hatched
		end

	to_brush_hatch: INTEGER is
		do
			Result := hatch
		end

end -- class HATCHED_BRUSH
