-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Graphics
	description: "Icon data"
	interface: client

class ICON

inherit
	WIN_OBJECT

	WIN_API

	RESOURCE_OBJECT

	DRAWABLE


creation
	make_resource

creation {WIN_API}
	make_handle

feature {CREATION_NONE} -- Creation

	make_resource (name: STRING) is
			-- Create from resource.
		do
			finalisation_register
			!!position.make
			set_handle (wrt.win_icon_rsc (wrt.ew_string (name).to_c))
		end

feature {NONE}

	make_handle (hdl: INTEGER) is
		do
			finalisation_register
			!!position.make
			set_handle (hdl)
		end

feature {NONE}
	
	position: POINT
			-- Position

feature -- (Optional) position

	set_position (pt: POINT) is
			-- Set position (used when drawn in a GRAPHIC_DEVICE).
		require
			valid_point: pt /= Void
		do
			position.copy (pt)
		end

feature {GRAPHIC_DEVICE}

	draw (gd: GRAPHIC_DEVICE) is
		do
			wrt.win_gdi_icon (gd.handle, handle, position.x, position.y)
		end

feature {NONE}

	dispose is
		do
			-- Nothing (unless CreateIcon)
			handle := Invalid_handle
		end

invariant
	valid_position: position /= Void

end -- class ICON
