-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Graphics
	description: "Logical colour palette"
	interface: client

class LOGICAL_PALETTE

inherit
	PALETTE
		end

creation
	make

feature {CREATION_NONE} -- Creation
	
	make (sz: INTEGER) is
			-- Create palette with `sz' colour entries.
		require
			valid_size: sz > 1
			valid_gdi_size: -- sz <= device.capabilities.palette_size
		local
			defcol: RGB_COLOR
			i: INTEGER
		do
			!!defcol.black
			!!pal.make (1, sz)
			from
				i := 1
			variant
				sz + 1 - i
			until
				i > sz
			loop
				pal.put (defcol, i)
				i := i + 1
			end
		end

feature
	
	size: INTEGER is
			-- Size of this palette.
		do
			Result := pal.count
		end

feature
	
	set_color (idx: INTEGER; col: RGB_COLOR) is
			-- Set palette colour at index `idx'.
			-- Lowest indexes have priority when electing sparse 
			-- hardware palette entries.
		require
			index: idx >= 1 and idx <= size
			color: col /= Void
		do
			pal.put (col, idx)
		ensure
			keep_reference: -- has (col)
		end

	color (idx: INTEGER): RGB_COLOR is
			-- Colour at index `idx'. 
		do
			Result := pal.item (idx)
		end

feature {NONE}
	
	pal: ARRAY[RGB_COLOR]

feature {WIN_API}
	
	to_windows: WIN_PALETTE is
		do
			!!Result.make (pal)
		end

end -- class LOGICAL_PALETTE
