-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Graphics
	description: "Simple pen -- traditional pre-Win32 pen"
	interface: client

class SIMPLE_PEN

inherit
	BASIC_PEN
		end

creation
	make
	
feature {CREATION_NONE} -- Creation

	make is
			-- Create default pen.
		do
			set_width (1)
			make_basic
		end
		
feature {NONE}
	
	width: INTEGER

feature -- Width

	set_width (wi: INTEGER) is
			-- Set pen width in _logical_ units. If width is zero 
			-- the pen is one _pixel_ width. Only line of solid style 
			-- (set_line_solid) support proper widths. Non-solid lines 
			-- width is one pixel. Geometric pens must be used for properly 
			-- scalable pens.
		require
			valid_width: wi >= 0
		do
			width := wi
		end

feature {WIN_API}
	
	to_windows: WIN_PEN is
		do
			!!Result.make_traditional (width, style, color)
		end

invariant
	valid_width: width >= 0

end -- class SIMPLE_PEN
