-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Internal, Controls
	description: "(Internal) dialog units"
	interface: client, internal

class DIALOG_UNITS

creation {DIALOG_ELEMENT, DIALOG}
	make

feature {NONE} -- Attributes

	dratio_x, dratio_y: DOUBLE

feature {DIALOG_ELEMENT, DIALOG} -- Creation

	make, set (dunitx, dunity: INTEGER) is
		do
			-- fp dialog units ratio
			dratio_x := dunitx / 4
			dratio_y := dunity / 8
		end

feature {NONE} -- (Internal)
	
	r2i (in: DOUBLE): INTEGER is
			-- Real to integer ...
		local
			sys: P_SYSTEM
		do
			!!sys
			Result := sys.floor (in)
		end

feature {DIALOG_ELEMENT, DIALOG} -- Independent/real coordinates conversion

	x_indep_to_abs (x: INTEGER): INTEGER is
		do
			Result := r2i (dratio_x * x)
		end

	y_indep_to_abs (y: INTEGER): INTEGER is
		do
			Result := r2i (dratio_y * y)
		end

	x_abs_to_indep (x: INTEGER): INTEGER is
		local
			d: DOUBLE
		do
			d := x -- portability
			Result := r2i (d / dratio_x)
		end

	y_abs_to_indep (y: INTEGER): INTEGER is
		local
			d: DOUBLE
		do
			d := y -- portability
			Result := r2i (d / dratio_y)
		end

	abs_to_indep (r: RECTANGLE): RECTANGLE is
		require
			valid: r /= Void
		local
			p1, p2: POINT
		do
			!!p1.make
			p1.set_x (x_abs_to_indep (r.lower.x))
			p1.set_y (y_abs_to_indep (r.lower.y))
			!!p2.make
			p2.set_x (x_abs_to_indep (r.upper.x))
			p2.set_y (y_abs_to_indep (r.upper.y))

			!!Result.make_points (p1, p2)
		end

	indep_to_abs (r: RECTANGLE): RECTANGLE is
		require
			valid: r /= Void
		local
			p1, p2: POINT
		do
			!!p1.make
			p1.set_x (x_indep_to_abs (r.lower.x))
			p1.set_y (y_indep_to_abs (r.lower.y))
			!!p2.make
			p2.set_x (x_indep_to_abs (r.upper.x))
			p2.set_y (y_indep_to_abs (r.upper.y))
			!!Result.make_points (p1, p2)
		end

end -- class DIALOG_UNITS
