-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Internal
	description: "Window Event"
	interface: client, internal

class WIN_EVENT

creation {NOTIFIER}
	make

feature {NONE} -- Creation

	make (win: WINDOW;cd: INTEGER;ch: CHARACTER;i1, i2: INTEGER) is
			-- Create (initialise parameters).
		do
			window := win
			code := cd
			char := ch
			int1 := i1
			int2 := i2
		end

feature {WINDOW}
	
	window: WINDOW
			-- Event window
	
	code: INTEGER
			-- Event code

	int1: INTEGER
			-- message: INTEGER #1
	int2: INTEGER
			-- message: INTEGER #2
	char: CHARACTER
			-- message: CHARACTER

feature {WINDOW} -- extended access

	point: POINT is
			-- Parameters as a point for mouse events
		do
			!!Result.make_coord (int1, int2)
		end

	vkey: VIRTUAL_KEY is
			-- Virtual key for 
		do
			!!Result.make_value (int1)
		end

feature {NOTIFIER}
	
	execute is
			-- Process the event
		do
			window.when_event (Current)
		end

invariant
	good_window: window /= Void

end -- class WIN_EVENT
