-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Internal
	description: "Hold a reference to an OS GUI object"
	interface: internal, inheritance
	
deferred class WIN_OBJECT

inherit
	WIN_MEMORY

feature {WIN_API} -- Value
	
	handle: INTEGER

feature {WIN_API, WIN_OBJECT} -- Validity, for assertions
	
	Invalid_handle: INTEGER is 0

	is_valid_handle: BOOLEAN is
			-- Is the current handle valid?
		do
			Result := handle /= Invalid_handle
		ensure
			definition: Result = (handle /= Invalid_handle)
		end

feature {WIN_API} -- Interface

	set_handle (h: INTEGER) is
			-- Set the handle value.
		do
			handle := h
		end

	reset_handle is
			-- Make handle invalid.
		do
			handle := Invalid_handle
		ensure
			invalid: handle = Invalid_handle
		end

	force_dispose is
			-- Force invalidation/freeing of handle.
		do
			dispose
		end

end -- class WIN_OBJECT

