-- Pylon: a foundation library; version 0.82(beta); 1998-01-04

-- 
-- Copyright (c) 1997 Franck Arnaud, England, E.U.
-- 
-- Permission is hereby granted, without written agreement and without
-- licence or royalty fees, to use, copy, modify, or distribute this source
-- code or binary programs using it or part of it, subject to the following
-- condition:
-- 
-- The above copyright notice and the following disclaimer must appear in
-- all copies or substantial portions of this source code. (Binary programs
-- derived from the source code can be distributed without restriction or
-- mention of the origin of the source.)
-- 
-- THIS SOFTWARE IS PROVIDED BY FRANCK ARNAUD AND THE AUTHORS ``AS IS'' AND
-- ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-- IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-- ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHORS BE LIABLE TO ANY PARTY FOR 
-- ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
-- DAMAGES ARISING IN ANY WAY OUT OF THE USE OF THIS SOURCE CODE.
-- 

class TEST_DRIVEL inherit TESTER end

creation execute
	
feature
	
	execute is
		do
			-- test for P_RANDOM
			init_drivel
			-- indirect test for P_CATALOG
			compress_drivel
		end

	compress_drivel is
		local
			tc : TEST_COMPRESS
			cdrivel : STRING
		do
			!!tc

			put_title("Compress drivel...")
			cdrivel := tc.compress(drivel)
			
			put_string("drivel compressed: ")
			put_int(drivel.count)
			put_string(" -> ")
			put_int(cdrivel.count)
			put_string(" (")
			put_int(100-((cdrivel.count * 100) // drivel.count))
			put_string(" %% saved)")
			put_nl

			check
				reversible: drivel.is_equal(tc.decompress(cdrivel))
				reproduce_random: drivel.count = 557
				reproduce_compress: cdrivel.count = 210
			end
		end

	init_drivel is
		local
			subjects, verbs, objects : P_SEQUENCE_LIST[STRING]
			rand : P_RANDOM
			sentence : STRING
			i : INTEGER
		do
			put_title("Generate drivel:")

			-- init components
			!!subjects.make
			subjects.add("The cat")
			subjects.add("A squirrel")
			subjects.add("The Eiffelist")

			!!verbs.make
			verbs.add("sees")
			verbs.add("eats")
			verbs.add("congratulates")
			verbs.add("ignores")

			!!objects.make
			objects.add("a mouse")
			objects.add("the car")
			objects.add("the house")
			objects.add("some cheese")
			objects.add("the compiler")

			from 
				!!sentence.make(0)
				!!rand.make(12345) -- always the same
				i := Max_drivel 
			variant i until i = 0 loop
				rand.get_number(1, subjects.count)
				subjects.set_index(rand.last_number)
				sentence.append_string(subjects.item)
				sentence.append_character(' ')

				rand.get_number(1, verbs.count)
				verbs.set_index(rand.last_number)
				sentence.append_string(verbs.item)
				sentence.append_character(' ')

				rand.get_number(1, objects.count)
				objects.set_index(rand.last_number)
				sentence.append_string(objects.item)
				sentence.append_character('.')

				put_string(sentence)
				put_nl

				if drivel = Void then
					!!drivel.make(0)
				else
					drivel.append_character(' ')
				end
				drivel.append_string(sentence)

				sentence.wipe_out
				i := i - 1
			end

			put_nl
		end

feature {NONE}
	
	Max_drivel : INTEGER is 20
	drivel : STRING

end
