-- Pylon: a foundation library; version 0.82(beta); 1998-01-04

-- 
-- Copyright (c) 1997 Franck Arnaud, England, E.U.
-- 
-- Permission is hereby granted, without written agreement and without
-- licence or royalty fees, to use, copy, modify, or distribute this source
-- code or binary programs using it or part of it, subject to the following
-- condition:
-- 
-- The above copyright notice and the following disclaimer must appear in
-- all copies or substantial portions of this source code. (Binary programs
-- derived from the source code can be distributed without restriction or
-- mention of the origin of the source.)
-- 
-- THIS SOFTWARE IS PROVIDED BY FRANCK ARNAUD AND THE AUTHORS ``AS IS'' AND
-- ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-- IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-- ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHORS BE LIABLE TO ANY PARTY FOR 
-- ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
-- DAMAGES ARISING IN ANY WAY OUT OF THE USE OF THIS SOURCE CODE.
-- 

class TEST_SET_TABLE

inherit
	TESTER
		end

creation
	execute

feature {NONE}
	
	int_set : P_SET[INTEGER]
	dict : P_TABLE[STRING,STRING]

	Big_size : INTEGER is 500

feature
	
	execute is
		do
			put_title("SET:")
			!P_HASH_SET[INTEGER]!int_set.make
			test_integer_set
		end

	test_integer_set is
		local
			i : INTEGER
		do
			int_set.add(-1)
			int_set.add(-6)
			int_set.add(-4)
			put_string("has -6? ")
			put_string(int_set.has(-6).out)
			check has_six: int_set.has(-6) end
			put_nl
			
			-- test resize policy
			put_string("grow. count: ")
			put_string(int_set.count.out)
			put_nl

			from -- grow
				i := 1
			variant
				Big_size - i + 1
			until
				i > Big_size
			loop
				int_set.add(i)
				i := i + 1
			end
			
			put_string("shrink. count: ")
			put_string(int_set.count.out)
			put_nl

			from -- shrink
				i := 1
			variant
				Big_size - i + 1
			until
				i > Big_size
			loop
				check found: int_set.has(i) end
				int_set.search(i)
				int_set.remove
				check found_not: not int_set.has(i) end
				i := i + 1
			end
			
			put_int_list(int_set.to_list)

			put_string("count: ") 
			put_string(int_set.count.out)
			put_nl 

		end

feature {NONE} -- misc output methods.

	put_int_list(il : P_LIST[INTEGER]) is
		local
			it : P_ITERATOR[INTEGER]
		do
			from
				it := il.iterator
				it.first
			variant it.forward_variant until it.outside loop
				put_string(it.item.out)
				put_string(" ")
				it.forth
			end
			put_nl
		end

	put_string_list(sl : P_LIST[STRING]) is
		local
			it : P_ITERATOR[STRING]
		do
			from
				it := sl.iterator
				it.first
			variant it.forward_variant until it.outside loop
				put_string(it.item)
				put_nl

				it.forth
			end
			put_nl
		end

end

