-- Pylon: a foundation library; version 0.82(beta); 1998-01-04

-- 
-- Copyright (c) 1997 Franck Arnaud, England, E.U.
-- 
-- Permission is hereby granted, without written agreement and without
-- licence or royalty fees, to use, copy, modify, or distribute this source
-- code or binary programs using it or part of it, subject to the following
-- condition:
-- 
-- The above copyright notice and the following disclaimer must appear in
-- all copies or substantial portions of this source code. (Binary programs
-- derived from the source code can be distributed without restriction or
-- mention of the origin of the source.)
-- 
-- THIS SOFTWARE IS PROVIDED BY FRANCK ARNAUD AND THE AUTHORS ``AS IS'' AND
-- ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-- IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-- ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHORS BE LIABLE TO ANY PARTY FOR 
-- ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
-- DAMAGES ARISING IN ANY WAY OUT OF THE USE OF THIS SOURCE CODE.
-- 

class TESTOBJ

inherit
	P_TEXT_OBJECT
		redefine
			out
		end

creation
	make

feature
	
	make is
		do
			str := "Hello %%world"
			bool := false
			char := 'z'
			int := -1887
			sreal := 3.1415927E-20
			dreal := -1.123456789012345678901234567890
		end

feature
	
	str : STRING
	bool : BOOLEAN
	char : CHARACTER
	int : INTEGER
	sreal : REAL
	dreal : DOUBLE

feature
	
	done : BOOLEAN
	
	out : STRING is
			-- Printable object.
		do
			!!Result.make(0)
			Result.append_character('[')
			Result.append_string(done.out)
			Result.append_string("] ")
			Result.append_string(str)
			
			Result.append_character(' ')
			Result.append_string(bool.out)
			Result.append_character(' ')
			Result.append_character(char)
			Result.append_character(' ')
			Result.append_string(int.out)
			
			Result.append_character(' ')
			Result.append_string(sreal.out)
			Result.append_character(' ')
			Result.append_string(dreal.out)
		end

feature {PUBLIC_NONE }
	
	object_to_string(t : P_TEXT_OBJECT_MANAGER) is
		do
			t.put_string(str)
			t.put_boolean(bool)
			t.put_character(char)
			t.put_integer(int)
			t.put_real(sreal)
			t.put_double(dreal)
		end

	string_to_object(t : P_TEXT_OBJECT_MANAGER) is
		do
			t.get_string
			str := t.last_string
			t.get_boolean
			bool := t.last_boolean
			t.get_character
			char := t.last_character
			t.get_integer
			int := t.last_integer
			t.get_real
			sreal := t.last_real
			t.get_double
			dreal := t.last_double
			done := t.in_success
		end

end
