-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Bubble
	description: "Shadow for resizing rectangular object"
	interface: client

class BOX_RESIZE inherit BOX_SHADOW end

creation {BUBBLE_OBJECT}

	make_south, make_north, make_west, make_east,
	make_north_east, make_south_east, make_north_west, make_south_west
	
feature {NONE}
	
	make_north (p: RECTANGLE) is
		require
			ok: p /= Void
		do
			internal_make (p, North)
		end

	make_south (p: RECTANGLE) is
		require
			ok: p /= Void
		do
			internal_make (p, South)
		end
	
	make_east (p: RECTANGLE) is
		require
			ok: p /= Void
		do
			internal_make (p, East)
		end

	make_west (p: RECTANGLE) is
		require
			ok: p /= Void
		do
			internal_make (p, West)
		end

	make_north_east (p: RECTANGLE) is
		require
			ok: p /= Void
		do
			internal_make (p, North_east)
		end

	make_south_east (p: RECTANGLE) is
		require
			ok: p /= Void
		do
			internal_make (p, South_east)
		end
	
	make_north_west (p: RECTANGLE) is
		require
			ok: p /= Void
		do
			internal_make (p, North_west)
		end

	make_south_west (p: RECTANGLE) is
		require
			ok: p /= Void
		do
			internal_make (p, South_west)
		end

	internal_make (original_position: RECTANGLE; dir: INTEGER) is
		require
			ok: original_position /= Void
		do
			original := original_position
			direction := dir
			!!anchor.make
		ensure
			keep_reference: original = original_position
		end

feature {BUBBLE_OBJECT} -- Direction
	
	North, South, East, West, North_east, North_west, South_east, South_west: INTEGER is unique

feature {NONE} -- Attributes
	
	direction: INTEGER
	original: RECTANGLE
	anchor: POINT

feature
	
	position: RECTANGLE is
		local
			lower, upper: POINT
		do
			check
				has_original: original /= Void
				has_anchor: anchor /= Void
			end

			lower := original.lower
			upper := original.upper

			inspect
				direction
			when North then
				lower.set_y (anchor.y)
			when South then
				upper.set_y (anchor.y)
			when East then
				upper.set_x (anchor.x)
			when West then
				lower.set_x (anchor.x)
			when North_west then
				lower.copy (anchor)
			when South_east then
				upper.copy (anchor)
			when North_east then
				lower.set_y (anchor.y)
				upper.set_x (anchor.x)
			when South_west then
				lower.set_x (anchor.x)
				upper.set_y (anchor.y)
			end

			!!Result.make
			Result.set_points (lower, upper)
		end

feature
	
	set_anchor (an: POINT) is
		do
			anchor.copy (an)
		ensure then
			set: anchor.is_equal (an)
		end

end
