-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Bubble
	description: "Properties dialog for bubble"
	interface: client

class BUBBLE_PROPERTIES

inherit
	MODELESS_DIALOG
		end

creation
	make

feature -- Set client

	set_object (obj: BUBBLE) is
			-- Set associated object.
		require
			ok: obj /= Void
		do
			bubble := obj
			class_name.set_contents (bubble.class_name)
			if bubble.deferred_class then
				deferred_class.check_mark
			end
		ensure
			keep_reference: bubble = obj
		end

	set_draw (dw: BUBBLE_DRAW) is
			-- Associated draw window.
		require
			ok: dw /= Void
		do
			draw := dw
		ensure
			keep_reference: draw = dw
		end

feature {NONE}
	
	bubble: BUBBLE
	draw: BUBBLE_DRAW

	class_name: STRINGBOX
	deferred_class: CHECKBOX

feature {PUBLIC_NONE}
	
	when_prepared is
		local
			label: STD_LABEL
			ok, cancel: PUSH_BUTTON
		do
			set_text ("Class properties")

			!!label.make (Current)
			label.set_label ("Class &name")

			!STD_STRINGBOX!class_name.make (Current)
			class_name.place_under (label)
			class_name.indep_set_width (100)
			label.same_width (class_name)

			!STD_CHECKBOX!deferred_class.make (Current)
			deferred_class.set_label ("&Deferred class")
			deferred_class.adapt_width
			deferred_class.place_under (class_name)
			
			!OK_BUTTON!ok.make (Current)
			ok.set_label ("&OK")
			ok.place_right (label)
			set_ok_push_button (ok)

			!CANCEL_BUTTON!cancel.make (Current)
			cancel.set_label ("&Cancel")
			cancel.place_under (ok)
			set_cancel_push_button (cancel)

			arrange
		end

	when_finished is
		do
		end

	when_applied is
		do
			bubble.set_name (class_name.contents)
			bubble.set_deferred (deferred_class.is_checked)
			draw.paint_logical_rectangle (bubble.bounding_box)
		end

end -- class BUBBLE_PROPERTIES
