-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Bubble
	description: "File|Save as... command"
	interface: client

class CMD_FILE_SAVE_AS inherit GUI_COMMAND end

creation make
	
feature {NONE}
	
	make (nw: BUBBLE_DRAW) is
		do
			draw := nw
		end

feature {NONE}
	
	draw: BUBBLE_DRAW

feature
	
	execute is
		local
			msg: MESSAGE_BOX
			fd: FILE_SAVE_DIALOG
			tf: F_TEXTFILE
		do
			if draw.drw.is_blank then
				!!msg.make (draw.overlapped_parent)
				msg.set_title ("Blank drawing")
				msg.set_text ("No drawing to save.")
				msg.set_buttons_ok
				msg.execute
			else -- not blank
				!!fd.make (draw.overlapped_parent)
				fd.add_filter ("Bubble", "*.bub")
				fd.execute

				if fd.has_selection then
					!!tf.make
					tf.set_name (fd.last_file_name)
					tf.set_mode_write
					tf.connect
					if tf.is_alive then
						draw.name.set (fd.last_file_name)
						draw.drw.save_drawing (tf)
						tf.disconnect
					end
				end
			end
		end

end
