-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra
	description: "Title of window including current file name"
	interface: client

class FILE_TITLE

creation
	make

feature {NONE} -- Creation
	
	make (ow: OVERLAPPED_WINDOW) is
			-- Initialise.
		require
			ok: ow /= Void
		do
			parent := ow
		ensure
			keep_reference: parent = ow
		end

feature {NONE} -- Private attribute(s)

	parent: OVERLAPPED_WINDOW

feature -- Attribute(s)

	name: STRING

feature

	has: BOOLEAN is
			-- Name set?
		do
			Result := name /= Void
		end

	set (nm: STRING) is
			-- Change file name.
		require
			ok: nm /= Void
		do
			if not (name /= Void and then name.is_equal (nm)) then
				!!name.make (0)
				name.copy (nm)
				apply
			end
		end

	reset is
			-- Untitled file.
		do
			name := Void
		end

	apply is
			-- Change displayed name.
		local
			title: STRING
		do
			!!title.make (0)
			title.copy ("Fenestra Bubble - ")
			if name = Void then
				title.append_string ("untitled")
			else
				title.append_string (name)
			end
			parent.set_text (title)
		end

end -- class FILE_TITLE
