-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Samples
	description: "Generic sample dialog"
	interface: client

class HELLODIALOG

inherit
	MODELESS_DIALOG
		end

creation
	make

feature {NONE}
	
	listbox: STD_MULTIPLE_LISTBOX[LISTBOX_STRING]
	scrollbar: STD_SCROLLBAR
	progress: PROGRESS_BAR

feature {PUBLIC_NONE}
	
	when_prepared is
		local
			ok, cancel: PUSH_BUTTON
			chk: CHECKBOX
			radio: HEAD_RADIO_BUTTON
			radio1, radio2: RADIO_BUTTON
			gbox: STD_GROUP_BOX
			lbi: LISTBOX_STRING
			lst: P_LIST[LISTBOX_STRING]
			lab: STD_LABEL
			strb: STD_STRINGBOX
			txtb: STD_TEXTBOX
			combo1: STD_DROPDOWN_LISTBOX[LISTBOX_STRING]
			combo2: STD_COMBOBOX[LISTBOX_STRING]
			cmd: GUI_COMMAND
			bmpbutton: BITMAP_BUTTON
		do
			-- title
			set_text ("Fenestra Dialog Box")

			-- controls
			
			!STD_CHECKBOX!chk.make (Current)
			chk.set_label ("C&heck box")
			chk.adapt_width
			
			!!gbox.make (Current)
			gbox.place_under (chk)

			!STD_HEAD_RADIO!radio.make (Current)
			radio.set_label ("&Radio button")
			radio.adapt_width
			gbox.arrange_first (radio)

			!STD_RADIO_BUTTON!radio1.make (Current)
			radio1.set_label ("R&adio 1");
			radio1.set_leader (radio)
			radio1.place_just_under (radio)
			radio1.adapt_width

			!STD_RADIO_BUTTON!radio2.make (Current)
			radio2.set_label ("Ra&dio 2");
			radio2.set_leader (radio)
			radio2.place_just_under (radio1)
			radio2.adapt_width
			
			gbox.arrange (radio2)
			chk.same_width (gbox)
			
			!!bmpbutton.make (Current)
			bmpbutton.set_resource ("TestBMP")
			bmpbutton.place_under (gbox)
			!CMD_HELLOBUTTON!cmd.make (Current)
			bmpbutton.set_command (cmd)

			!!progress.make (Current)
			progress.place_right (bmpbutton)

			!!scrollbar.make_horizontal (Current)
			!CMD_HELLOSCROLL!cmd.make (Current)
			scrollbar.set_command (cmd)
			scrollbar.place_under (bmpbutton)
			scrollbar.indep_set_width (50)
			
			!!lab.make (Current)
			lab.set_label ("&Listbox:")
			lab.adapt_width --indep_set_width (50)
			lab.place_right (chk)
			
			!!listbox.make (Current)
			!CMD_HELLOLIST_EXEC!cmd.make (Current)
			listbox.set_execute_command (cmd)
			!CMD_HELLOLIST_SELECT!cmd.make (Current)
			listbox.set_select_command (cmd)
				!P_LINKED_LIST[LISTBOX_STRING]!lst.make
				!!lbi.make ("Eiffel")
				lst.add (lbi)
				!!lbi.make ("C/C++")
				lst.add (lbi)
				!!lbi.make ("Java")
				lst.add (lbi)
				!!lbi.make ("BETA")
				lst.add (lbi)
			listbox.add_list (lst)
				!!lbi.make ("Lisp")
			listbox.add_item (lbi)
			listbox.place_just_under (lab)
			listbox.indep_set_width (100)
			listbox.indep_set_height (50)

			!!strb.make (Current)
			strb.set_contents ("Hello")
			strb.place_under (listbox)
			strb.indep_set_width (100)

			!!txtb.make (Current)
			txtb.place_under (scrollbar)
			txtb.indep_set_width (200)
			txtb.indep_set_height (100)

			!!combo1.make_unsorted (Current)
			combo1.place_right (listbox)
			combo1.indep_set_width (80)
			combo1.add_list (lst)

			!!combo2.make_unsorted (Current)
			combo2.place_under (combo1)
			combo2.same_width (combo1)
			combo2.add_list (lst)

			-- ok button
			!OK_BUTTON!ok.make (Current)
			ok.set_label ("&OK")
			ok.set_command (cmd)
			ok.place_under (txtb)
			ok.left_of_center

			!CANCEL_BUTTON!cancel.make (Current)
			cancel.set_label ("&Cancel")
			cancel.place_right (ok)

			-- set size
			arrange
		end

	when_finished is
		do
		end

	when_applied is
		do
		end

feature {GUI_COMMAND}
	
	list_select is
		local
			it: P_ITERATOR[LISTBOX_STRING]
			s: STRING
		do
			!!s.make (0)
			s.copy ("Selected>")
			s.append_string (listbox.selected_item.name)
			s.append_character (':')

			from
				it := listbox.selected_range.iterator
				it.first
			variant
				it.forward_variant
			until
				it.outside
			loop
				s.append_string (it.item.name)
				s.append_character (' ')
				it.forth
			end
			
			message (s)
		end

	list_exec is
		do
			message (listbox.selected_item.name)
		end

	scroll is
		do
			progress.set_position (scrollbar.units_to_ratio (scrollbar.slider_position))
		end

feature -- message

	message (str: STRING) is
		do
			set_text (str)
		end
	
end -- class HELLODIALOG
