-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Tutorial, Tictactoe
	description: "Options dialog box"
	interface: client

class GAME_DIALOG

inherit
	MODELESS_DIALOG
		end

creation
	make

feature {NONE} -- Controls
	
	computer: HEAD_RADIO_BUTTON
	user: RADIO_BUTTON
	list: LISTBOX[GAME_ITEM]

feature {NONE} -- Client
	
	client: VIEW

feature {PUBLIC_NONE} -- Start
	
	when_prepared is
			-- Initialise dialog.
		local
			group: STD_GROUP_BOX
			label: STD_LABEL
			ok, cancel: STD_PUSH_BUTTON
			listitem: GAME_ITEM
		do
			-- Set title
			set_text ("Game options")

			-- Initialise controls
			!!group.make (Current)
			group.set_label ("First move")

			!STD_HEAD_RADIO!computer.make (Current)
			computer.set_label ("Com&puter")
			computer.adapt_width
			group.arrange_first (computer)

			!STD_RADIO_BUTTON!user.make (Current)
			user.set_label ("&User")
			user.set_leader (computer)
			user.place_just_under (computer)
			user.same_width (computer)
			group.arrange (user)

			!!label.make (Current)
			label.set_label ("&Level:")
			label.adapt_width
			label.place_under (group)

			!STD_DROPDOWN_LISTBOX[GAME_ITEM]!list.make_unsorted (Current)
			list.place_right (label)

			group.align_right (list)

			!OK_BUTTON!ok.make (Current)
			ok.place_right (group)
			ok.set_label ("&OK")

			!CANCEL_BUTTON!cancel.make (Current)
			cancel.set_label ("&Cancel")
			cancel.place_under (ok)

			-- Resize dialog to enclose all controls
			arrange
			
			-- Initialise controls
			client ?= parent
			check good_client: client /= Void end
			
			-- Initialise radio buttons
			if client.firstmove_computer then
				computer.check_mark
			else
				user.check_mark
			end

			-- Initialise listbox
			!!listitem.make (1, "Easy")
			add_item (listitem)
			!!listitem.make (2, "Normal")
			add_item (listitem)
			!!listitem.make (3, "Difficult")
			add_item (listitem)
			!!listitem.make (4, "Expert")
			add_item (listitem)
		end

feature {NONE}
	
	add_item (litem: GAME_ITEM) is
		require
			ok: litem /= Void
		do
			list.add_item (litem)
			if litem.level = client.level then
				list.select_item (litem)
			end
		end

feature {PUBLIC_NONE} -- OK

	when_applied is
			-- Apply settings.
		do
			check selected: list.has_selection end
			client.set_level (list.selected_item.level)
			
			if computer.is_checked then
				client.set_firstmove_computer
			else
				client.set_firstmove_user
			end
		end

	when_finished is
		do
		end

end -- class GAME_DIALOG
