-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, System
	description: "Asynchronous stream"
	interface: inheritance

deferred class F_ASYNCH_STREAM

inherit
	F_STREAM
		end

feature -- Status of asynchronous communications

	is_connect_readable: BOOLEAN is
			-- Is the stream open in read mode?
		deferred
		end

	is_connect_writable: BOOLEAN is
			-- Is the stream open in write mode?
		deferred
		end

	is_readable: BOOLEAN is
			-- Is the stream currently readable?
		do
			Result := is_connect_readable and not is_reading
		ensure then
			asynch: Result implies not is_reading
		end

	is_writable: BOOLEAN is
			-- Is the stream currently writable?
		do
			Result := is_connect_writable and not is_writing
		ensure then
			asynch: Result implies not is_writing
		end

	is_reading: BOOLEAN is
			-- Is a read operation currently under way?
		deferred
		end

	is_writing: BOOLEAN is
			-- Is a write operation currently under way?
		deferred
		end

feature {PUBLIC_NONE} -- Event(s)

	when_connected is
			-- Connection has been established.
		require
			alive: is_alive
		deferred
		end

	when_read is
			-- Last read operation terminated.
		require
			finished: not is_reading
		deferred
		end

	when_written is
			-- Last write operation terminated.
		require
			finished: not is_writing
		deferred
		end

	when_died is
			-- Connection died.
		require
			dead: not is_alive
		deferred
		end

end -- class F_ASYNCH_STREAM
