-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, System
	description: "Finite (random-access) stream"
	interface: abstract

deferred class F_FINITE_STREAM

inherit
	F_STREAM
		end

feature -- Position
	
	set_position (idx: INTEGER) is
			-- Set current position in stream.
		require
			alive: is_alive
			valid_pos: idx >= 1 and idx <= size
		deferred
		ensure
			done: not has_error implies position = idx
		end

	position: INTEGER is
			-- Current position in the stream.
		require
			alive: is_alive
		deferred
		ensure
			bounds: position >= 1 and position <= size
		end

	size: INTEGER is
			-- Current size of stream in bytes.
		require
			alive: is_alive
		deferred
		end

end -- class F_FINITE_STREAM
