-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, System, Synchronisation
	description: "Semaphore"
	interface: client, inheritance

class F_SEMAPHORE

inherit
	F_SYNCH_OBJECT

creation
	make, make_existing

feature {CREATION_NONE} -- Creation
	
	make (nm: STRING; max_count: INTEGER) is
			-- Create semaphore or open existing.
			-- Default: semaphore count is `max_count'.
		require
			ok: nm /= Void and then not is_valid_name (nm)
			ok_count: max_count > 0
		do
			finalisation_register
			set_handle (wrt.win_sema_create (wrt.ew_string (nm).to_c, max_count))
		ensure
			done: -- is_valid set
		end

	make_existing (nm: STRING) is
			-- Open existing semaphore.
		require
			ok: nm /= Void and then not is_valid_name (nm)
		do
			finalisation_register
			set_handle (wrt.win_sema_open (wrt.ew_string (nm).to_c))
		ensure
			done: -- is_valid set
		end

feature -- State
	
	release is
			-- Release one semaphore slot.
		do
			wrt.win_sema_release (handle)
		end

end -- class F_SEMAPHORE
