-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Windows
	description: "Access to the windows clipboard"
	interface: abstract

deferred class CLIPBOARD

inherit
	WIN_API
		end

feature {CREATION_NONE} -- Creation

	make (p: WINDOW) is
			-- Create clipboard object.
		require
			valid: p /= Void and then p.is_valid
		do
			parent := p
		ensure
			keep_reference: parent = p
		end

feature {NONE}
	
	parent: WINDOW

feature {NONE}
	
	internal_put is 
		deferred
		end

	internal_get is
		deferred
		end

feature -- Clipboard access
	
	put is
			-- Put the current information in the clipboard.
		do
			check valid: parent.is_valid end
			if wrt.win_clip_open (parent.handle) = true then
				wrt.win_clip_empty
				internal_put
				wrt.win_clip_close
			end
			--? else retry?
		end

	get is
			-- Get information from the clipboard.
		require
			has_selection: has_data
		do
			check valid: parent.is_valid end
			has_result := false
			if wrt.win_clip_open (parent.handle) = true then
				internal_get
				wrt.win_clip_close
			end
			--? else retry?
		ensure
			done: -- has_result set
		end

	has_data: BOOLEAN is
			-- Does the clipboard has a selection for this kind of object?
		deferred
		end

	has_result: BOOLEAN;
			-- Result of last `get' operation.

end -- class CLIPBOARD
