-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Windows, Clipboard
	description: "Clipboard access for graphic metafiles"
	interface: client

class CLIPBOARD_BITMAP

inherit
	CLIPBOARD
		end

creation
	make

feature
	
	has_data: BOOLEAN is
			-- Is a bitmap available?
		do
			Result := wrt.win_clip_has (wrt.Cf_bitmap)
		end

feature {NONE}
	
	bitmap: BITMAP_DEVICE
	last_handle: INTEGER

feature 
	
	set_bitmap (bm: BITMAP_DEVICE) is
			-- Set a metafile for copying to the clipboard.
		require
			ready: bm.is_ready
			stays_ready: -- bm.is_ready when put too.
		do
			has_result := false
			bitmap := bm
		ensure
			keep_reference: bitmap = bm
		end

	last_bitmap: BITMAP_DEVICE is
			-- Last retrieved drawable metafile.
		require
			possible: has_result
		do
			!!Result.make_handle (last_handle)
		end

feature {NONE}
	
	internal_put is
		do
			check has_bm: bitmap /= Void end
			if bitmap.is_ready then
				wrt.win_clip_copy (wrt.Cf_bitmap, bitmap.bitmap.handle)
			end
		end

	internal_get is
		do
			last_handle := wrt.win_clip_paste (wrt.Cf_bitmap)
			has_result := (last_handle /= 0)
		end
		
end -- class CLIPBOARD_BITMAP
