-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Windows, Clipboard
	description: "Text clipboard"
	interface: client

class CLIPBOARD_TEXT

inherit
	CLIPBOARD
		end

creation
	make

feature
	
	has_data: BOOLEAN is
			-- Is clipboard text available?
		do
			Result := wrt.win_clip_hastext
		end

feature -- Data

	set_text (txt: P_LIST[STRING]) is
			-- Set text to be copied to the clipboard.
		require
			valid: txt /= Void
		local
			wsl: WIN_STRING_LIST
		do
			!!wsl
			datastr := wsl.list_to_string (txt)
			has_result := false
		end

feature {NONE}
	
	datastr: STRING

feature -- Result

	last_text: P_LIST[STRING] is
		require
			possible: has_result
		local
			wsl: WIN_STRING_LIST
		do
			!!wsl
			Result := wsl.string_to_list (datastr)
		ensure
			is_copy: Result /= Void
		end

feature {NONE}
	
	internal_put is
		do
			wrt.win_clip_copytext (wrt.ew_string (datastr).to_c)
		end

	internal_get is
		do
			wrt.win_clip_pastetext
			datastr := wrt.win_laststring
			has_result := true
		end

end -- class CLIPBOARD_TEXT
