-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Windows
	description: "Standard font selection box"
	interface: client

class FONT_DIALOG

inherit
	STANDARD_DIALOG
		end

creation
	make

feature {CREATION_NONE} -- Creation
	
	make (p: OVERLAPPED_WINDOW) is
		do
			parent := p
			win_color := 0 -- black
			!!win_font.make
			has_selection := false
		end

feature
	
	set_color (clr: COLOR) is
			-- Set the default colour, user will be allowed to 
			-- select text colour.
		require
			valid: clr /= Void
		do
			ask_color := true
			win_color := clr.to_windows
		end

	no_color is
			-- Do not allow the user to select text colour.
		do
			ask_color := false
		end

	color: COLOR is
			-- Selected text colour. 
		require
			done: has_selection
		do
			check colour_required: ask_color end
			!STANDARD_COLOR!Result.make (win_color)
		ensure
			is_copy: Result /= Void
		end

	set_font (ft: LOGICAL_FONT) is
			-- Set the default font.
		require
			valid: ft /= Void
		do
			has_font := true
			win_font.copy (ft)
		end

	font: LOGICAL_FONT is
			-- Selected font.
		require
			done: has_selection
		do
			!!Result.make
			Result.copy (win_font)
		ensure
			is_copy: Result /= Void
		end

feature -- Execution

	has_selection: BOOLEAN
			-- Has the dialog box been processed?
	
	execute is
			-- Display the dialog box.
		local
			win_point: INTEGER
		do
			win_font.prepare_dialog
			has_selection := wrt.win_std_font (parent.handle, win_color, ask_color, has_font,
					win_font.struct.to_windows)
			if has_selection then
				win_color := wrt.win_lastint1
				win_point := wrt.win_lastint2
				win_font.set_point (win_point)
			end
		end

feature {NONE}
	
	parent: WINDOW
	win_color: INTEGER
	has_font, ask_color: BOOLEAN
	win_font: LOGICAL_FONT

end -- class FONT_DIALOG
