-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Windows
	description: "Mouse-pointer cursor"
	interface: client

class MOUSE_CURSOR

inherit
	WIN_OBJECT

	WIN_API

	RESOURCE_OBJECT


creation
	make_void,
	make_resource,
	make_arrow, make_cross, make_i_beam, make_no,
	make_up_arrow, make_wait, make_app_starting,
	make_size_north_south, make_size_west_east,
	make_size_nw_se, make_size_ne_sw

feature {CREATION_NONE} -- Void cursor

	make_void is
			-- Create cursor object (for current cursor manipulation).
		do
		ensure
			not_valid: not is_valid
		end

feature {CREATION_NONE} -- Creation

	make_arrow is
			-- Make standard arrow cursor.
		do
			set_handle (wrt.win_cursor_std (wrt.Idc_arrow))
		end

	make_cross is
		do
			set_handle (wrt.win_cursor_std (wrt.Idc_cross))
		end

	make_i_beam is
		do
			set_handle (wrt.win_cursor_std (wrt.Idc_ibeam))
		end

	make_no is
		do
			set_handle (wrt.win_cursor_std (wrt.Idc_no))
		end

	make_up_arrow is
		do
			set_handle (wrt.win_cursor_std (wrt.Idc_uparrow))
		end

	make_wait is
		do
			set_handle (wrt.win_cursor_std (wrt.Idc_wait))
		end

	make_app_starting is
		do
			set_handle (wrt.win_cursor_std (wrt.Idc_appstarting))
		end

	make_size_north_south is
		do
			set_handle (wrt.win_cursor_std (wrt.Idc_sizens))
		end

	make_size_west_east is
		do
			set_handle (wrt.win_cursor_std (wrt.Idc_sizewe))
		end

	make_size_nw_se is
		do
			set_handle (wrt.win_cursor_std (wrt.Idc_sizenwse))
		end

	make_size_ne_sw is
		do
			set_handle (wrt.win_cursor_std (wrt.Idc_sizenesw))
		end

	make_resource (name: STRING) is
			-- Load cursor from resource.
		do
			finalisation_register
			set_handle (wrt.win_cursor_rsc (wrt.ew_string (name).to_c))
		end

feature -- Status

	is_valid: BOOLEAN is
		do
			Result := is_valid_handle
		end

feature -- Current mouse cursor.

	apply is
			-- Set current cursor to be this one (valid 
			-- until next mouse movement).
		require
			valid_cursor: is_valid
		do
			wrt.win_cursor_set (handle)
		end

	show_cursor is
			-- Show current mouse cursor.
		do
			wrt.win_cursor_show (true)
		end

	hide_cursor is
			-- Hide current mouse cursor.
		do
			wrt.win_cursor_show (false)
		end

feature {NONE} -- Finalisation

	dispose is
		do
			-- nothing to do unless manually created (CreateCursor)
			handle := Invalid_handle
		end
	
end -- class MOUSE_CURSOR
