-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Windows
	description: "Pop-up menu"
	interface: client

class POPUP_MENU

inherit
	MENU
		end
	WIN_API
		end

creation
	make

feature {CREATION_NONE} -- Creation

	make (par: OVERLAPPED_WINDOW) is
			-- Create a popup menu, which can be added to a bar or 
			-- to another popup menu.
		require
			valid: par /= Void
		do
			initialize -- init MENU
			parent := par
			set_handle (wrt.win_menu_cpopup)
			!!name.make (0)
		ensure
			done: is_valid
			keep_reference: par = parent
		end

feature {MENU}
	
	name: STRING 

feature -- Menu name
	
	set_name (s: STRING) is
			-- Set the menu name. It will be used when the menu is 
			-- attached to a another popup menu or a menu bar.
		require
			valid_menu: is_valid
			valid_string: s /= Void
		do
			name.copy (s)
		end

feature -- Installation & Destruction

	pop_up (p: POINT) is
			-- Display & process popup menu
		require
			valid_point: p /= Void
		do
			wrt.win_menu_track (handle, parent.handle, p.x, p.y)
		end

	destroy is
			-- Destroy the menu.
		require
			stand_alone: -- not attached to a window (menu bar)
		do
			--? correct comment/implementation?
			wrt.win_menu_destroy (handle)
			reset_handle
		ensure
			done: not is_valid
		end

feature {NONE} -- Finalisation

	dispose is
		do
			--? bar-attached menu destroyed by Windows??
			handle := Invalid_handle
		end

invariant
	valid_name: name /= Void
	
end -- class POPUP_MENU
