-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Windows
	description: "Popup window - overlapped window which stays on top of its parent"
	interface: inheritance

class POPUP_WINDOW

inherit
	OVERLAPPED_WINDOW
		end

creation
	make_popup

feature {CREATION_NONE}
	
	make_popup (p: like parent) is
			-- Create the popup window
		require
			parent_ok: p /= Void and then p.is_valid
		do
			parent := p
			!!wo.make_handle (wrt.win_create_popup (parent.handle))
			register
		ensure
			created: is_valid
			keep_reference: parent = p
		end

end -- class POPUP_WINDOW
