-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Windows
	description: "Standard printer setup dialog box"
	interface: client

class PRINT_DIALOG

inherit
	STANDARD_DIALOG
		end

creation
	make

feature {CREATION_NONE} -- Creation

	make (p: OVERLAPPED_WINDOW) is
			-- Create.
		do
			parent := p
			get_device := true
		end

feature {NONE}
	
	parent: WINDOW
	get_device: BOOLEAN
	
	idevice: PRINTER_DEVICE

feature -- Dialog
	
	has_selection: BOOLEAN is
			-- Has the last execution be successful?
		do
			Result := idevice /= Void
		end

	execute is
			-- Display print dialog box.
		local
			device_handle: INTEGER
		do
			device_handle := wrt.win_std_print (parent.handle, get_device, false)
			if device_handle /= 0 then
				!!idevice.make_handle (device_handle)
			else
				idevice := Void
			end
		end

feature -- Result
	
	device: PRINTER_DEVICE is
			-- Selected printer device.
		require
			executed: has_selection
		do
			Result := idevice 
		end

end -- class PRINT_DIALOG
