-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Windows
	description: "Abstract standard dialog provided by the operating system"
	interface: abstract

deferred class STANDARD_DIALOG

inherit
	WIN_API
		end

feature {CREATION_NONE} -- Creation

	make (p: OVERLAPPED_WINDOW) is
			-- Create a standard dialog.
		require
			valid: p /= Void
		deferred
		ensure
			keep_reference: -- of `p'.
		end

feature -- Execution

	has_selection: BOOLEAN is
			-- Has the dialog been executed?
		deferred
		end

	execute is
			-- Display the standard dialog and process input from the user.
			-- (This procedure returns when the user is finished).
		require
			repaint_parent: -- not parent.device.is_ready
		deferred
		ensure
			done: -- has_selection set
		end

end -- class STANDARD_DIALOG
