-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Xcontrols
	description: "Generic `About' box"
	comment: "`make' is creation procedure"
	interface: inheritance

deferred class ABOUT_BOX

inherit
	MODELESS_DIALOG
		end

feature -- Default events

	when_applied is
			-- Default: no event.
		do
		end

	when_finished is
			-- Default: no event.
		do
		end

feature {NONE}
	
	icon_ctl: STD_ICON
	line_ctl: STD_LABEL
	space: BOOLEAN

	Icon_space: INTEGER is 10

feature {NONE}
	
	translate (ctl: DIALOG_ELEMENT) is
		local
			r: RECTANGLE
			p: POINT
		do
			r := ctl.indep_size
			p := r.lower
			p.set_x (p.x + Icon_space)
			r.translate_lower (p)
			ctl.indep_set_size (r)
		end

feature -- About box layout (used during when_created)

	is_first: BOOLEAN is
			-- Is this line the first line?
		do
			Result := icon_ctl = Void
		end

	add_icon (ico: ICON) is
			-- Set about box's icon.
		require
			ok: ico /= Void
			first: is_first
		do
			!!icon_ctl.make (Current)
			icon_ctl.set_icon (ico)
			translate (icon_ctl)
			space := false
		ensure
			one_only: not is_first
		end

	add_line (str: STRING) is
			-- Add line to about box.
		require
			ok: str /= Void
			not_first: not is_first
		local
			line: STD_LABEL
		do
			!!line.make (Current)
			line.set_label (str)
			line.adapt_width
			if line_ctl /= Void then
				if space then
					line.place_under (line_ctl)
					space := false
				else
					line.place_just_under (line_ctl)
				end
			else
				line.place_right (icon_ctl)
				translate (line)
			end
			line_ctl := line
		end

	add_space is
			-- Add some space under current line.
		require
			not_first: not is_first
		do
			space := true
		end

	add_button (txt: STRING) is 
			-- Add OK button and resize box.
		require
			ok: txt /= Void
			not_first: not is_first
			last: -- after lines.
		local
			okb: OK_BUTTON
		do
			!!okb.make (Current)
			okb.set_label (txt)

			check has_lines: line_ctl /= Void end
			okb.place_under (line_ctl)
			okb.center

			arrange
		end

end -- class ABOUT_BOX
