-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Xcontrols
	description: "Bitmap button"
	interface: client

class BITMAP_BUTTON

inherit
	PUSH_BUTTON
		end
	CONTROL
		end

creation
	make

feature {CREATION_NONE} -- Creation

	make (pw: WINDOW) is
			-- Create bitmap button.
		do
			!BITMAP_BUTTON_WINDOW!self.make (pw, Current)
			register
		end

feature -- Effect PUSH_BUTTON

	is_down: BOOLEAN;
			-- Is button down?
	is_default: BOOLEAN;
			-- Is this button the default button?

	set_down (down: BOOLEAN) is
			-- Change button status.
		do
			is_down := down
			self.paint
		end

	set_default (dft: BOOLEAN) is
			-- Change default status.
		do
			if dft = true then get_default else lose_default end
			is_default := dft
			self.paint
		end

	set_label (str: STRING) is
			-- Label unimplemented for bitmap buttons.
		do
			-- Possible extension: optional label under bitmap.
		ensure then
			unimplemented: false
		end

feature {BITMAP_BUTTON_WINDOW}
	
	bitmap: BITMAP_DEVICE

feature
	
	set_bitmap (bmp: BITMAP_DEVICE) is
			-- Set associated bitmap.
		require
			ok: bmp /= Void
		do
			bitmap := bmp
		ensure
			keep_reference: bitmap = bmp
		end

	set_resource (name: STRING) is
			-- Load bitmap from resource.
		require
			ok: name /= Void
			valid_resource: -- executable.has_resource (name)
		do
			self.device.prepare
			!!bitmap.make (self.device)
			bitmap.load_resource (name)
			self.device.release
			adjust_size
		end

	adjust_size is
			-- Resize the button to the size of the bitmap.
		require
			has_bitmap: -- set_bitmap or set_ressource
		local
			rect: RECTANGLE
		do
			check has_bitmap: bitmap /= Void end

			-- reset indep_size cache
			isize := Void 
			
			!!rect.make
			rect.set_width (bitmap.width+4)
			rect.set_height (bitmap.height+4)
			self.set_client_size (rect)
		end

end
