-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Xcontrols
	description: "Implementation of mouse button handler for BITMAP_BUTTON"
	interface: internal, client

class BITMAP_BUTTON_MOUSE 

inherit 
	MOUSE_HANDLER
		rename
			make as old_make
		redefine
			when_down, when_dragged, when_up
		end

creation {BITMAP_BUTTON_WINDOW}
	make

feature {NONE}
	
	button: BITMAP_BUTTON

feature {NONE}
	
	make (win: BITMAP_BUTTON_WINDOW) is
			-- Create mouse handler.
		do
			button := win.control
			old_make (win)
		end

feature {PUBLIC_NONE}

	when_down is
			-- Mouse down.
		do
			button.set_down (true)
		end

	when_dragged is
			-- Mouse is being dragged.
		do
			if button.self.client_size.has_point (point) then -- in
				if not button.is_down then
					button.set_down (true)
				end
			else -- out
				if button.is_down then
					button.set_down (false)
				end
			end
			check drag_ok: button.self.client_size.has_point (point) = button.is_down end
		end

	when_up is
			-- Mouse button up.
		do
			if button.is_down then
				button.set_down (false)
				button.execute
			end
			check button_ok: not button.is_down end
		end

end
