-- Fenestra; version 0.80(beta); 1998-09-27

-- 
-- Copyright (c) 1998 Franck Arnaud, http://www.altsoft.demon.co.uk/
-- 
-- This package is distributed under the Eiffel Forum Freeware License, 
-- version 1 (see file forum.txt for full text). The main points are:
-- 
-- "Permission is hereby granted, without written agreement and without 
--  license or royalty fees, to use, copy, modify and/or distribute this 
--  package, provided that: copyright notices are retained unchanged [...]
-- 
--  Permission is hereby also granted [...] to distribute binary programs 
--  which depend on this package, provided that: if the binary program 
--  depends on a modified version of this package, you must publicly release 
--  the modified version of this package [...].
-- 
--  THIS PACKAGE IS PROVIDED "AS IS" AND WITHOUT WARRANTY [...]"
-- 

indexing
	cluster: Fenestra, Xcontrols
	description: "Implementation of bitmap button"
	interface: internal

class BITMAP_BUTTON_WINDOW

inherit
	CONTROL_WINDOW
		redefine
			control,
			when_created, when_drawn, 
			when_focus_given, when_focus_lost,
			when_key_pressed, when_key_released
		end

creation
	make

feature {NONE} -- Creation

	make (pw: WINDOW; ctl: BITMAP_BUTTON) is
		do
			set_control (ctl)
			make_child (pw)
		end

feature {BITMAP_BUTTON_MOUSE} -- Associated control.

	control: BITMAP_BUTTON

feature {PUBLIC_NONE}
	
	when_created is
			-- Creation.
		local
			mouse: BITMAP_BUTTON_MOUSE
		do
			set_border (false)

			-- Initialise mouse manager (for is_down status)
			!!mouse.make (Current)
			set_left_mouse_manager (mouse)
		end

	when_drawn is
			-- Draw window.
		local
			rect: RECTANGLE
			pt: POINT
			d3: DRAW_3D_CONTROLS
			bmp: BITMAP_DEVICE
		do
			!!d3 
		
			-- draw border
			d3.draw_button (device, client_size, control.is_down)
			
			-- draw bitmap
			bmp := control.bitmap
			if bmp /= Void then

				-- centre
				!!rect.make
				rect.set_width (bmp.width)
				rect.set_height (bmp.height)
				rect.translate_center (client_size.center)
				pt := rect.lower
				if control.is_down then
					pt.set_xy (pt.x + 1, pt.y + 1)
				end

				-- actual draw
				bmp.set_position (pt)
				device.draw (bmp)
			end
		end
	
	when_focus_given is
			-- Focus (default handling).
		do
			control.set_default (true)
		end

	when_focus_lost is
			-- Focus lost.
		do
			control.set_default (false)
		end

	when_key_pressed (vk: VIRTUAL_KEY) is
			-- Key pressed (space shortcut).
		do
			if vk.is_space then
				control.set_down (true)
			else
				control_when_key_pressed (vk)
			end
		end
	
	when_key_released (vk: VIRTUAL_KEY) is
			-- Key released.
		do
			if control.is_down and then vk.is_space then
				control.set_down (false)
				control.execute
			end
		end

end -- class BITMAP_BUTTON_WINDOW

